//+--------------------------------------------------------------------------+
//|                      Donchian Channel MTF Histo + Shift & Outside Levels |
//|                     Made by airquest - 06/19/2014 - airquest@hotmail.com |
//|                                        First posted on www.forex-tsd.com |
//+--------------------------------------------------------------------------+

#property  copyright "Open Source - Give me money with PayPal if you want"
#property  link      "http://www.world-record.ch/donate"

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers  27

//---- indicator parameters
extern string _______ChannelSettings_______  ="========= Channel Settings ========";
extern int    Periods               =26;
extern int    TimeFrame             =PERIOD_CURRENT;
extern int    ChannelShift          =0;
extern bool   ShowMainHLLines       =True;      //Show High & Low lines
extern bool   ShowMiddleLine        =True;      //Show middle line
extern bool   ShowFirstLevels       =True;      //Show inside 1st levels
extern bool   ShowSecondLevels      =True;      //Show inside 2nd levels
extern double LowestLevel           =16.66;
extern double LowLevel              =33.33;
extern double HighLevel             =66.66;
extern double HighestLevel          =83.33;

extern string _______HistogramsSettings_______  ="========= Histograms Settings ========";
extern bool   ShowHistoHL1st        =True;      //Histogram between HL and first levels
extern bool   ShowHisto1st2nd       =True;      //Histogram between first and second levels
extern bool   ShowHisto2ndMid       =True;      //Histogram between second levels and middle line

extern string _______ChannelStyle_______  ="========= Channel Style ========";
extern string HighLineStyle         =STYLE_SOLID;
extern string HighLineWidth         =3;
extern color  HighLineColor         =White;
extern string LowLineStyle          =STYLE_SOLID;
extern string LowLineWidth          =3;
extern color  LowLineColor          =White;

extern string _______MiddleLineStyle_______  ="========= Middle Line Style ========";
extern string MiddleLineStyle       =STYLE_SOLID;
extern string MiddleLineWidth       =3;
extern color  MiddleLineColor       =Blue;

extern string _______FirstLevelsStyle_______  ="========= First Levels Style ========";
extern string FirstLevelsStyle      =STYLE_DOT;
extern string FirstLevelsWidth      =1;
extern color  FirstLevelsColor      =DarkGray;

extern string _______SecondLevelsStyle_______  ="========= Second Levels Style ========";
extern string SecondLevelsStyle     =STYLE_DOT;
extern string SecondLevelsWidth     =1;
extern color  SecondLevelsColor     =DarkGray;

extern string _______HistogramsStyle_______  ="========= Histograms Style ========";
extern string HistoDn               ="== Style for histograms below middle line ==";
extern string HistoHL1stDn          ="Lowest histo (between Low and 1st level)";
extern string HistoHL1stDnStyle     =STYLE_SOLID;                          
extern string HistoHL1stDnWidth     =5;
extern color  HistoHL1stDnColor     =Red;
extern string Histo1st2ndDn         ="Lower histo (between 1st and 2nd levels)";
extern string Histo1st2ndDnStyle    =STYLE_SOLID;
extern string Histo1st2ndDnWidth    =5;
extern color  Histo1st2ndDnColor    =Orange;
extern string Histo2ndMidDn         ="Low histo (between 2nd level and middle line)";
extern string Histo2ndMidDnStyle    =STYLE_SOLID;
extern string Histo2ndMidDnWidth    =5;
extern color  Histo2ndMidDnColor    =Yellow;

extern string HistoUp               ="== Style for histograms above middle Line ==";
extern string HistoHL1stUp          ="High histo (between middle line and 2nd level)";
extern string Histo2ndMidUpStyle    =STYLE_SOLID;
extern string Histo2ndMidUpWidth    =5;
extern color  Histo2ndMidUpColor    =Chartreuse;
extern string Histo1st2ndUp         ="Higher histo (between 2nd and 1st levels)";
extern string Histo1st2ndUpStyle    =STYLE_SOLID;
extern string Histo1st2ndUpWidth    =5;
extern color  Histo1st2ndUpColor    =LimeGreen;
extern string Histo2ndMidUp         ="Highest histo (between 1st level and High)";
extern string HistoHL1stUpStyle     =STYLE_SOLID;
extern string HistoHL1stUpWidth     =5;
extern color  HistoHL1stUpColor     =Green;

//---- outside levels & shift settings
extern string ________OutsideLevelsSettings________     ="========= Outside Levels Settings ========";
extern string ______________WordOfCaution_____________  ="== Using OL makes sense only if levels are shifted ==";

extern int    OutsideLevelsShift    =26;
extern bool   ShowOutsideLevels     =False;
extern bool   ShowOutsideHisto      =False;
extern string OutsideLevelsCalcul   ="H+/L- percentage of HL";
extern double LowerLevel1           =33.33;
extern double LowerLevel2           =50;
extern double UpperLevel1           =33.33;
extern double UpperLevel2           =50;

extern string _______OutsideLevelsStyle_______ ="========= Outside Levels Style =========";
extern string LowerLevelsStyle      =STYLE_SOLID;
extern string LowerLevelsWidth      =2;
extern color  LowerLevelsColor      =DarkOrange;
extern string UpperLevelsStyle      =STYLE_SOLID;
extern string UpperLevelsWidth      =2;
extern color  UpperLevelsColor      =Lime;

extern string _______OutsideHistoStyle_______ ="========= Outside Histo Style =========";
extern string LowerHistoStyle       =STYLE_DOT;
extern string LowerHistoWidth       =5;
extern color  LowerHistoColor       =Red;
extern string UpperHistoStyle       =STYLE_DOT;
extern string UpperHistoWidth       =5;
extern color  UpperHistoColor       =Green;

//---- indicator buffers
double Upper[];
double Lower[];
double Middle[];
double Middle2[];
double LowestLevel_Buffer[];
double LowestLevel_Buffer2[];
double LowLevel_Buffer[];
double LowLevel_Buffer2[];
double HighLevel_Buffer[];
double HighLevel_Buffer2[];
double HighestLevel_Buffer[];
double HighestLevel_Buffer2[];
double UpperLevel1_Buffer[];
double UpperLevel2_Buffer[];
double LowerLevel1_Buffer[];
double LowerLevel2_Buffer[];
double Upper_Line[];
double Lower_Line[];
double Middle_Line[];
double LowestLevel_Buffer_Line[];
double HighestLevel_Buffer_Line[];
double LowLevel_Buffer_Line[];
double HighLevel_Buffer_Line[];
double UpperLevel1_Buffer_Line[];
double UpperLevel2_Buffer_Line[];
double LowerLevel1_Buffer_Line[];
double LowerLevel2_Buffer_Line[];

//+------------------------------------------------------------------+
//| custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {
//---- indicator buffers mapping
      IndicatorBuffers(27);
//---- histograms buffers
      SetIndexBuffer(0,Lower);
      SetIndexBuffer(1,LowestLevel_Buffer);
      SetIndexBuffer(2,LowestLevel_Buffer2);
      SetIndexBuffer(3,LowLevel_Buffer);
      SetIndexBuffer(4,LowLevel_Buffer2);
      SetIndexBuffer(5,Middle);
      SetIndexBuffer(6,Middle2);
      SetIndexBuffer(7,HighLevel_Buffer);
      SetIndexBuffer(8,HighLevel_Buffer2);
      SetIndexBuffer(9,HighestLevel_Buffer);
      SetIndexBuffer(10,HighestLevel_Buffer2);
      SetIndexBuffer(11,Upper);
      SetIndexBuffer(12,UpperLevel1_Buffer);
      SetIndexBuffer(13,UpperLevel2_Buffer);
      SetIndexBuffer(14,LowerLevel1_Buffer);
      SetIndexBuffer(15,LowerLevel2_Buffer);
//---- lines buffers
      SetIndexBuffer(16,Upper_Line);
      SetIndexBuffer(17,Lower_Line);
      SetIndexBuffer(18,Middle_Line);
      SetIndexBuffer(19,LowestLevel_Buffer_Line);
      SetIndexBuffer(20,HighestLevel_Buffer_Line);
      SetIndexBuffer(21,LowLevel_Buffer_Line);
      SetIndexBuffer(22,HighLevel_Buffer_Line);
      SetIndexBuffer(23,UpperLevel1_Buffer_Line);
      SetIndexBuffer(24,UpperLevel2_Buffer_Line);
      SetIndexBuffer(25,LowerLevel1_Buffer_Line);
      SetIndexBuffer(26,LowerLevel2_Buffer_Line);

//---- shift settings
   for (int i=0; i<12; i++)
   {
   if(TimeFrame>Period()) SetIndexShift(i,ChannelShift*TimeFrame/Period()); else SetIndexShift(i,ChannelShift);
   }
   for (i=16; i<23; i++)
   {
   if(TimeFrame>Period()) SetIndexShift(i,ChannelShift*TimeFrame/Period()); else SetIndexShift(i,ChannelShift);
   }
   for (i=12; i<16; i++)
   {
   if(TimeFrame>Period()) SetIndexShift(i,OutsideLevelsShift*TimeFrame/Period()); else SetIndexShift(i,OutsideLevelsShift);
   }
   for (i=23; i<27; i++)
   {
   if(TimeFrame>Period()) SetIndexShift(i,OutsideLevelsShift*TimeFrame/Period()); else SetIndexShift(i,OutsideLevelsShift);
   }

//---- histo drawing settings
   if(ShowHistoHL1st)
   {
      SetIndexStyle(0,DRAW_HISTOGRAM,HistoHL1stDnStyle,HistoHL1stDnWidth,HistoHL1stDnColor);
      SetIndexStyle(1,DRAW_HISTOGRAM,HistoHL1stDnStyle,HistoHL1stDnWidth,HistoHL1stDnColor);
      SetIndexStyle(10,DRAW_HISTOGRAM,HistoHL1stUpStyle,HistoHL1stUpWidth,HistoHL1stUpColor);
      SetIndexStyle(11,DRAW_HISTOGRAM,HistoHL1stUpStyle,HistoHL1stUpWidth,HistoHL1stUpColor);    
   }
   else
   {
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(10,DRAW_NONE);
      SetIndexStyle(11,DRAW_NONE);
   }

   if(ShowHisto1st2nd)
   {
      SetIndexStyle(2,DRAW_HISTOGRAM,Histo1st2ndDnStyle,Histo1st2ndDnWidth,Histo1st2ndDnColor);
      SetIndexStyle(3,DRAW_HISTOGRAM,Histo1st2ndDnStyle,Histo1st2ndDnWidth,Histo1st2ndDnColor);
      SetIndexStyle(8,DRAW_HISTOGRAM,Histo1st2ndUpStyle,Histo1st2ndUpWidth,Histo1st2ndUpColor);
      SetIndexStyle(9,DRAW_HISTOGRAM,Histo1st2ndUpStyle,Histo1st2ndUpWidth,Histo1st2ndUpColor);
   }
   else
   {
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(8,DRAW_NONE);
      SetIndexStyle(9,DRAW_NONE);
   }

   if(ShowHisto2ndMid)
   {
      SetIndexStyle(4,DRAW_HISTOGRAM,Histo2ndMidDnStyle,Histo2ndMidDnWidth,Histo2ndMidDnColor);
      SetIndexStyle(5,DRAW_HISTOGRAM,Histo2ndMidDnStyle,Histo2ndMidDnWidth,Histo2ndMidDnColor);
      SetIndexStyle(6,DRAW_HISTOGRAM,Histo2ndMidUpStyle,Histo2ndMidUpWidth,Histo2ndMidUpColor);
      SetIndexStyle(7,DRAW_HISTOGRAM,Histo2ndMidUpStyle,Histo2ndMidUpWidth,Histo2ndMidUpColor);
   }
   else
   {
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
      SetIndexStyle(6,DRAW_NONE);
      SetIndexStyle(7,DRAW_NONE);
   }

   if(ShowOutsideHisto)
   {
      SetIndexStyle(12,DRAW_HISTOGRAM,UpperHistoStyle,UpperHistoWidth,UpperHistoColor);
      SetIndexStyle(13,DRAW_HISTOGRAM,UpperHistoStyle,UpperHistoWidth,UpperHistoColor);
      SetIndexStyle(14,DRAW_HISTOGRAM,LowerHistoStyle,LowerHistoWidth,LowerHistoColor);
      SetIndexStyle(15,DRAW_HISTOGRAM,LowerHistoStyle,LowerHistoWidth,LowerHistoColor);
   }
   else
   {
      SetIndexStyle(12,DRAW_NONE);
      SetIndexStyle(13,DRAW_NONE);
      SetIndexStyle(14,DRAW_NONE);
      SetIndexStyle(15,DRAW_NONE);
   }

//---- lines drawing settings
   if(ShowMainHLLines)     SetIndexStyle(16,DRAW_LINE,HighLineStyle,HighLineWidth,HighLineColor);              else SetIndexStyle(16,DRAW_NONE);
   if(ShowMainHLLines)     SetIndexStyle(17,DRAW_LINE,LowLineStyle,LowLineWidth,LowLineColor);                 else SetIndexStyle(17,DRAW_NONE);
   if(ShowMiddleLine)      SetIndexStyle(18,DRAW_LINE,MiddleLineStyle,MiddleLineWidth,MiddleLineColor);        else SetIndexStyle(18,DRAW_NONE);
   if(ShowFirstLevels)     SetIndexStyle(19,DRAW_LINE,FirstLevelsStyle,FirstLevelsWidth,FirstLevelsColor);     else SetIndexStyle(19,DRAW_NONE);
   if(ShowFirstLevels)     SetIndexStyle(20,DRAW_LINE,FirstLevelsStyle,FirstLevelsWidth,FirstLevelsColor);     else SetIndexStyle(20,DRAW_NONE);
   if(ShowSecondLevels)    SetIndexStyle(21,DRAW_LINE,SecondLevelsStyle,SecondLevelsWidth,SecondLevelsColor);  else SetIndexStyle(21,DRAW_NONE);
   if(ShowSecondLevels)    SetIndexStyle(22,DRAW_LINE,SecondLevelsStyle,SecondLevelsWidth,SecondLevelsColor);  else SetIndexStyle(22,DRAW_NONE);
   if(ShowOutsideLevels)   SetIndexStyle(23,DRAW_LINE,UpperLevelsStyle,UpperLevelsWidth,UpperLevelsColor);     else SetIndexStyle(23,DRAW_NONE);
   if(ShowOutsideLevels)   SetIndexStyle(24,DRAW_LINE,UpperLevelsStyle,UpperLevelsWidth,UpperLevelsColor);     else SetIndexStyle(24,DRAW_NONE);
   if(ShowOutsideLevels)   SetIndexStyle(25,DRAW_LINE,LowerLevelsStyle,LowerLevelsWidth,LowerLevelsColor);     else SetIndexStyle(25,DRAW_NONE);
   if(ShowOutsideLevels)   SetIndexStyle(26,DRAW_LINE,LowerLevelsStyle,LowerLevelsWidth,LowerLevelsColor);     else SetIndexStyle(26,DRAW_NONE);

//---- names for DataWindow and indicator subwindow label
   SetIndexLabel(16,"Upper");
   SetIndexLabel(17,"Lower");
   SetIndexLabel(18,"Middle");
   SetIndexLabel(19,"Lowest Level");
   SetIndexLabel(20,"Highest Level");
   SetIndexLabel(21,"Low Level");
   SetIndexLabel(22,"High Level");
   SetIndexLabel(23,"Outside Up Level");
   SetIndexLabel(24,"Outside Upper Level");
   SetIndexLabel(25,"Outside Low Level");
   SetIndexLabel(26,"Outside Lower Level");

   switch(TimeFrame)
   {
      case 1:     string TimeFrameStr="Period_M1"; break;
      case 5:     TimeFrameStr="Period_M5";        break;
      case 15:    TimeFrameStr="Period_M15";       break;
      case 30:    TimeFrameStr="Period_M30";       break;
      case 60:    TimeFrameStr="Period_H1";        break;
      case 240:   TimeFrameStr="Period_H4";        break;
      case 1440:  TimeFrameStr="Period_D1";        break;
      case 10080: TimeFrameStr="Period_W1";        break;
      case 43200: TimeFrameStr="Period_MN1";       break;
      default:    TimeFrameStr="Current Timeframe";
   }
   
   IndicatorShortName("Donchian Channel ("+Periods+") " +TimeFrameStr);

//---- initialization done
   return(0);
  }

//+------------------------------------------------------------------+
//| channel calculation                                              |
//+------------------------------------------------------------------+

int start()
  {
   datetime TimeArray[];
   int i, y=0, limit, counted_bars=IndicatorCounted();
   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame);

//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

//---- calculate values
   for(i=0,y=0; i<limit; i++)
   {
      if (Time[i]<TimeArray[y]) y++;
      
      if(TimeFrame>Period())
      {
      Upper[i]=   Upper_Line[i]=    iHigh(NULL,TimeFrame,iHighest(NULL,TimeFrame,MODE_HIGH,Periods,y));
      Lower[i]=   Lower_Line[i]=    iLow (NULL,TimeFrame,iLowest (NULL,TimeFrame,MODE_LOW, Periods,y));
      }
      else
      {
      Upper[i]=   Upper_Line[i]=    iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Periods,i));
      Lower[i]=   Lower_Line[i]=    iLow (NULL,0,iLowest (NULL,0,MODE_LOW, Periods,i));
      }
      
      Middle[i]=              Middle2[i]=                Middle_Line[i]=               (Upper[i]+Lower[i])/2;
      LowestLevel_Buffer[i]=  LowestLevel_Buffer2[i]=    LowestLevel_Buffer_Line[i]=   Lower[i]+(Upper[i]-Lower[i])*LowestLevel/100;
      HighestLevel_Buffer[i]= HighestLevel_Buffer2[i]=   HighestLevel_Buffer_Line[i]=  Lower[i]+(Upper[i]-Lower[i])*HighestLevel/100;
      LowLevel_Buffer[i]=     LowLevel_Buffer2[i]=       LowLevel_Buffer_Line[i]=      Lower[i]+(Upper[i]-Lower[i])*LowLevel/100;
      HighLevel_Buffer[i]=    HighLevel_Buffer2[i]=      HighLevel_Buffer_Line[i]=     Lower[i]+(Upper[i]-Lower[i])*HighLevel/100;
      
      UpperLevel1_Buffer[i]=  UpperLevel1_Buffer_Line[i]=   Upper[i]+(Upper[i]-Lower[i])*UpperLevel1/100;
      UpperLevel2_Buffer[i]=  UpperLevel2_Buffer_Line[i]=   Upper[i]+(Upper[i]-Lower[i])*UpperLevel2/100;
      LowerLevel1_Buffer[i]=  LowerLevel1_Buffer_Line[i]=   Lower[i]-(Upper[i]-Lower[i])*LowerLevel1/100;
      LowerLevel2_Buffer[i]=  LowerLevel2_Buffer_Line[i]=   Lower[i]-(Upper[i]-Lower[i])*LowerLevel2/100;
   }

   return(0);
  }

//+------------------------------------------------------------------+